//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers    3
#property indicator_color1     LimeGreen
#property indicator_color2     Orange
#property indicator_color3     Orange
#property indicator_width1     3
#property indicator_width2     3
#property indicator_width3     3

//
//
//
//
//

extern string TimeFrame          = "Current time frame";
extern int    AverageLength      = 14;
extern int    AveragePrice       = PRICE_CLOSE;
extern double Variance           = 1;
extern double Mean               = 0.0;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = false;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = false;
extern bool   alertsEmail        = false;
extern bool   alertsNotification = false;
extern bool   Interpolate        = true;

double  pdfma[];
double  pdfmada[];
double  pdfmadb[];
double  slope[];
double  coeffs[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

#define maxx 3.5
int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,pdfma);
   SetIndexBuffer(1,pdfmada);
   SetIndexBuffer(2,pdfmadb);
   SetIndexBuffer(3,slope);
   
      Variance = MathMax(Variance,0.01);
      Mean     = MathMax(MathMin(Mean,1.0),-1.0);
      ArrayResize(coeffs,AverageLength);   
         double step = maxx/(AverageLength-1); for(int i=0; i<AverageLength; i++) coeffs[i] = pdf(i*step,Variance,Mean*maxx);
   
         //
         //
         //
         //
         //
               
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { pdfma[0] = limit+1; return(0); }
         if (timeFrame!=Period())
         {
            limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            if (slope[limit]==-1) CleanPoint(limit,pdfmada,pdfmadb);         
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);
               pdfma[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",AverageLength,AveragePrice,Variance,Mean,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,0,y);
               pdfmada[i] = EMPTY_VALUE;
               pdfmadb[i] = EMPTY_VALUE;
               slope[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",AverageLength,AveragePrice,Variance,Mean,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,3,y);
                     if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

                     //
                     //
                     //
                     //
                     //

                     datetime time = iTime(NULL,timeFrame,y);
                     for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                     for(int k = 1; k < n; k++)
                        pdfma[i+k] = pdfma[i] + (pdfma[i+n] - pdfma[i]) * k/n;
            }         
            for(i=limit; i>=0; i--) if (slope[i]==-1) PlotPoint(i,pdfmada,pdfmadb,pdfma);
            return(0);
         }

   //
   //
   //
   //
   //
         
   if (slope[limit]==-1) CleanPoint(limit,pdfmada,pdfmadb);         
   for(i=limit; i>=0; i--)
   {
      pdfma[i] = iPdfma(iMA(NULL,0,1,0,MODE_SMA,AveragePrice,i),AverageLength,coeffs,i);
      pdfmada[i] = EMPTY_VALUE;
      pdfmadb[i] = EMPTY_VALUE;
      slope[i]   = slope[i+1];
         if (pdfma[i]>pdfma[i+1]) slope[i] =  1;
         if (pdfma[i]<pdfma[i+1]) slope[i] = -1;
         if (slope[i]==-1) PlotPoint(i,pdfmada,pdfmadb,pdfma);
   }         
   manageAlerts();
   return(0);
}


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] ==  1) doAlert(time1,mess1,whichBar,"pdfma slope changed to up");
         if (slope[whichBar] == -1) doAlert(time1,mess1,whichBar,"pdfma slope changed to down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS),doWhat);
          if (alertsMessage)      Alert(message);
          if (alertsEmail)        SendMail(StringConcatenate(Symbol()," pdfma "),message);
          if (alertsNotification) SendNotification(StringConcatenate(Symbol()," pdfma ",message));
          if (alertsSound)        PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//    normal probability density function
//
//

#define Pi 3.141592653589793238462643

double pdf(double x, double variance=1.0, double mean=0)
      { return((1.0/MathSqrt(2*Pi*MathPow(variance,2))*MathExp(-MathPow(x-mean,2)/(2*MathPow(variance,2))))); }

//
//
//
//
//

double workPdfma[][1];
double iPdfma(double price, double period, double& tcoeffs[], int r, int instanceNo=0)
{
   if (ArraySize(workPdfma)!= Bars) ArrayResize(workPdfma,Bars); r = Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workPdfma[r][instanceNo] = price;
      double sumw = tcoeffs[0];
      double sum  = tcoeffs[0]*price;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = tcoeffs[k];
                sumw  += weight;
                sum   += weight*workPdfma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}
  
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}